=== debian/changelog ===
gnuradio (3.7.3-9) unstable; urgency=low

  * Update to v3.7.3-37-gaffda0b
  * Additional codec2 updates
  * Avoid buggy comedilib

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 04 May 2014 14:07:49 -0400

gnuradio (3.7.3-8) unstable; urgency=low

  * No gr-fcd on hurd

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 15 Apr 2014 07:09:35 -0400

gnuradio (3.7.3-7) unstable; urgency=low

  * No comedi on hurd

 -- A. Maitland Bottoms <bottoms@petros.rf.org>  Mon, 14 Apr 2014 00:12:10 -0400

gnuradio (3.7.3-6) unstable; urgency=low

  * Avoid ALSA on hurd (patch bsd-hurd-alsa)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 13 Apr 2014 08:11:53 -0400

gnuradio (3.7.3-5) unstable; urgency=low

  * no thread affinity for hurd

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 12 Apr 2014 20:55:12 -0400

gnuradio (3.7.3-4) unstable; urgency=low

  * Update to v3.7.3-20-gb0dce1e
  * disable gr-fcd if libusb is not found on hurd (rather than fail)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 12 Apr 2014 17:08:58 -0400

gnuradio (3.7.3-3) unstable; urgency=low

  * Update to v3.7.3-18-gb1855f7
  * Update debian/patches/bsd-fcd since special case handling for
    kFreeBSD libusb is no longer needed since freebsd-libs 10.0-4

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 10 Apr 2014 19:12:43 -0400

gnuradio (3.7.3-2) unstable; urgency=low

  * Update to v3.7.3-17-gc3ef245
  * Update Codec2 library
  * Update Codec2 gnuradio blocks: Clayton Smith (argilo, VE3IRR)

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 09 Apr 2014 00:28:09 -0400

gnuradio (3.7.3-1) unstable; urgency=low

  * New upstream release

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 09 Mar 2014 20:55:45 -0400

gnuradio (3.7.2.2-1) unstable; urgency=low

  * New upstream bugfix release

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 08 Mar 2014 23:29:48 -0500

gnuradio (3.7.2.1-5~bpo70+1) wheezy-backports; urgency=low

  * Rebuild for wheezy-backports.

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 27 Jan 2014 23:14:55 -0500
